#define JAf2DrvNm   "JAf2Driver"
#define JAf2DrvNmW L"JAf2Driver"
 
#define FILE_DEVICE_JAf2Driver    0x00008400
 
#define JAf2Driver_START (ULONG) CTL_CODE(FILE_DEVICE_JAf2Driver,  \
                                          0x00,                    \
                                          METHOD_BUFFERED,         \
                                          FILE_ANY_ACCESS          \
                                         )
 
#define JAf2Driver_TEST  (ULONG) CTL_CODE(FILE_DEVICE_JAf2Driver,  \
                                          0x01,                    \
                                          METHOD_BUFFERED,         \
                                          FILE_ANY_ACCESS          \
                                         )                          
                                                                 
#define JAf2Driver_TEST2 (ULONG) CTL_CODE(FILE_DEVICE_JAf2Driver,  \
                                          0x02,                    \
                                          METHOD_OUT_DIRECT,       \
                                          FILE_ANY_ACCESS          \
                                         )                          
                                                                 
#define JAf2Driver_TEST3 (ULONG) CTL_CODE(FILE_DEVICE_JAf2Driver,  \
                                          0x03,                    \
                                          METHOD_OUT_DIRECT,       \
                                          FILE_ANY_ACCESS          \
                                         )                          
                                                                 
#define JAf2Driver_STOP  (ULONG) CTL_CODE(FILE_DEVICE_JAf2Driver,  \
                                          0xFF,                    \
                                          METHOD_BUFFERED,         \
                                          FILE_ANY_ACCESS          \
                                         )

#ifdef JAf2DriverKernelMode
  
typedef unsigned _int16 UInt16T;
  
// Some of the fields in the device extension are kept only in the master device object, some only in
// device objects created in JAf2DriverAddDevice.
  
typedef struct 
  {
   int             MyNumber;
   int             MyArray[4];
   ULONG           ulAddedDevObj;                     // count of device objects added in AddDevice.
   ULONG           ulOpen;                            // OPENs against device.
   ULONG           ulClose;                           // CLOSESs against device.
   ULONG           ulOpenFailed;                      // failed OPENs against device.
   ULONG           ulCloseFailed;                     // failed CLOSESs against device.
   ULONG           ulRtn2Needed1;                     // Rtn2 needed by dispatch routine.
   ULONG           ulRtn2Needed2;                     // Rtn2 needed by dispatch routine.
   ULONG           ulRtn2Entered;                     // Rtn2 entered.                       
   BOOLEAN         bDoHardBreak;
   union{
         char      MyStuff[100];
         KTIMER    MyTimer;
        };
   KSPIN_LOCK      JALock;
   IO_REMOVE_LOCK  RemoveLock;
   PDEVICE_OBJECT  pMstrDevObj;
   PDEVICE_OBJECT  pPhysDevObj;
   PDEVICE_OBJECT  pNextLowerDevObj;
   UNICODE_STRING  JAf2UniSymLinkName;
   UNICODE_STRING  JAf2UniDeviceName;
   ANSI_STRING     DriverName;
  } JAf2DeviceExtension,
    *pJAf2DeviceExtension;

#endif
  
typedef struct _JAf2DriverTestStr
  {
   ULONG     x1;
   ULONG     x2;
   ULONG     x3;
  }
   JAf2DriverTestStr, *pJAf2DriverTestStr;
  
